﻿using BusinessLogic;
using DatabaseImplement.models;
using DataContracts.bindingModels;
using DataContracts.viewModels;
using DocumentFormat.OpenXml.Bibliography;
using Microsoft.EntityFrameworkCore.ChangeTracking.Internal;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ClientForms
{
    
    public partial class Products : Form
    {
        private readonly ProductBL productBl = new();
        BindingList<ProductViewModel> list ;
        public Products()
        {
            InitializeComponent();
            

        }
        public void LoadData()
        {
            
            list = productBl.ReadList() != null ? new BindingList<ProductViewModel>(productBl.ReadList()) : new BindingList<ProductViewModel>();
            dataGridView.DataSource = list;
            dataGridView.MultiSelect = false;
            dataGridView.Columns["Id"].Visible = false;
            dataGridView.Columns["title"].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;

        }

        private void Products_Load(object sender, EventArgs e)
        {
            LoadData();
        }

        private void Products_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Insert)
            {
                
                dataGridView.Rows[^1].Cells["title"].Selected = true;
                dataGridView.BeginEdit(true);
            }
            if (e.KeyCode == Keys.Delete)
            {
                if(dataGridView.CurrentCell != null)
                {
                    DialogResult dialogResult = MessageBox.Show("Sure", "Some Title", MessageBoxButtons.YesNo);
                    if (dialogResult == DialogResult.Yes)
                        productBl.Delete(new ProductBindingModel { Id = (int)dataGridView.Rows[dataGridView.CurrentCell.RowIndex].Cells["Id"].Value });
                    LoadData();
                }
            }
        }

        private void dataGridView_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            if (dataGridView.Rows[e.RowIndex].Cells["title"].Value == null || string.IsNullOrEmpty(dataGridView.Rows[e.RowIndex].Cells["title"].Value.ToString()) )
            {
                
                return;
            }
            else
            {
                if((int)dataGridView.Rows[e.RowIndex].Cells["Id"].Value != 0)
                {
                    productBl.Update(new ProductBindingModel
                    {
                        Id = (int)dataGridView.Rows[e.RowIndex].Cells["Id"].Value,
                        title = dataGridView.Rows[e.RowIndex].Cells["title"].Value.ToString()
                    });
                }
                else
                {
                    productBl.Create(new ProductBindingModel
                    {
                        title = dataGridView.Rows[e.RowIndex].Cells["title"].Value.ToString()
                    });

                }
                LoadData();
            }
            
        }
    }
}
