﻿using DatabaseImplement.models;
using DataContracts.bindingModels;
using DataContracts.searchModels;
using DataContracts.storages;
using DataContracts.viewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DatabaseImplement.Implements
{
    public class ProductStorage : IProductStorage
    {
        public ProductViewModel? Delete(ProductBindingModel model)
        {
            using var context = new AppDataBase();
            var element = context.Products.FirstOrDefault(rec => rec.Id == model.Id);
            if (element != null)
            {
                context.Products.Remove(element);
                context.SaveChanges();
                return element.GetViewModel;
            }
            return null;
        }

        public ProductViewModel? GetElement(ProductSearchModel model)
        {
            if (!model.Id.HasValue)
            {
                return null;
            }
            using var context = new AppDataBase();
            return context.Products
                .FirstOrDefault(x => x.Id == model.Id)
                ?.GetViewModel;
        }

        public List<ProductViewModel> GetFullList()
        {
            using var context = new AppDataBase();
            return context.Products
                .Select(x => x.GetViewModel)
                .ToList();
        }

        public ProductViewModel? Insert(ProductBindingModel model)
        {
            var newProduct = Product.Create(model);
            if (newProduct == null)
            {
                return null;
            }
            using var context = new AppDataBase();
            context.Products.Add(newProduct);
            context.SaveChanges();
            return newProduct.GetViewModel;
        }

        public ProductViewModel? Update(ProductBindingModel model)
        {
            using var context = new AppDataBase();
            var product = context.Products.FirstOrDefault(x => x.Id == model.Id);
            if (product == null)
            {
                return null;
            }
            product.Update(model);
            context.SaveChanges();
            return product.GetViewModel;
        }
    }
}
